
;CodeVisionAVR C Compiler V2.05.6 
;(C) Copyright 1998-2012 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _i=R5
	.DEF _k=R4
	.DEF _tim0_ov=R7
	.DEF _tim0_ov1=R6
	.DEF _tim0_ov20=R9
	.DEF _tim1_ov=R8
	.DEF _tim2_ov=R11
	.DEF _n=R10
	.DEF _RX_OK=R13
	.DEF _RX_OK1=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP _timer1_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;
;         !!!!!
;
;This program was produced by the
;CodeWizardAVR V2.05.3 Standard
;Automatic Program Generator
; Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : RX nRF24L01+
;Version :
;Date    : 10.11.2013
;Author  :
;Company :
;Comments:
;RX nRF24L01+
;
;
;Chip type               : ATmega8
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;
;
;
; nRF24L01+
;
;
; nRF     Mega
; MOSI---MOSI
; MISO---MISO
;  SCK---SCK
;CSN     PORTB.2
;CE      PORTB.1
;IRQ     PORTB.0
;
;LED       PORTD.5   "-"
;Save FileSave  PORTD.2
;Servo K1       PORTC.0
;Servo K2       PORTC.1
;
;
;
;
;
;
;
;
;
;
;
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#include <delay.h>
;
;#include <stdio.h>
;
;#define   CSN   PORTB.2
;#define   CE    PORTB.1
;#define   IRQ   PINB.0
;#define   F1    20
;#define   F2    33
;#define   F3    55
;#define   F4    77
;#define   LED        PORTD.5  //  ->>  "-"
;#define   Input_FS   !PIND.2
;#define   Out_K1     PORTC.0
;#define   Out_K2     PORTC.1
;#define   Out_K3     PORTC.2
;#define   Out_K4     PORTC.3
;#define   Out_K5     PORTC.4
;#define   Out_K6     PORTC.5
;#define   Out_K7     PORTD.0
;#define   Out_K8     PORTD.1
;
;#define   Code_1      33
;#define   Code_2      45
;
;unsigned char i, k ;
;unsigned char data[32];
;unsigned char tim0_ov, tim0_ov1,  tim0_ov20, tim1_ov, tim2_ov ; //  tim0_ov2,
;unsigned char n;
;
;unsigned char RX_OK,  RX_OK1;
;unsigned char F; // F1, F2, F3, F4;  //   
;unsigned char  RX_Fail;    //
;
;unsigned char FS_On; //   
;
;unsigned int Kanal[8], K_H, K_L ;   //   
;unsigned int F_Kanal[8];
;eeprom unsigned int E_F_Kanal[8];
;
;void Safe(void);
;void FileSafe(void);
;void Out_Kanal(void);
;void SET_RF_Channel(unsigned char a);
;
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 006B {

	.CSEG
_timer0_ovf_isr:
	RCALL SUBOPT_0x0
; 0000 006C //  1 MHz   !!!
; 0000 006D //    22 ,      filesafe
; 0000 006E //  1 Mhz  22.016 ms == 86 timer0_ovf
; 0000 006F 
; 0000 0070 tim0_ov++;
	INC  R7
; 0000 0071 if ( tim0_ov >= 86 )   //  22 ms                   //      200 ===   //  51,2 ms
	LDI  R30,LOW(86)
	CP   R7,R30
	BRLO _0x3
; 0000 0072       {
; 0000 0073       tim0_ov=0;
	CLR  R7
; 0000 0074       tim0_ov1++;
	INC  R6
; 0000 0075 
; 0000 0076       LED=0;
	CBI  0x12,5
; 0000 0077 
; 0000 0078       n=0;
	CLR  R10
; 0000 0079       Out_Kanal();  //    
	RCALL _Out_Kanal
; 0000 007A 
; 0000 007B       if (tim0_ov1>10)  // 220 ms
	LDI  R30,LOW(10)
	CP   R30,R6
	BRSH _0x6
; 0000 007C           {
; 0000 007D           tim0_ov1=0;
	CLR  R6
; 0000 007E           tim0_ov20++;
	INC  R9
; 0000 007F           if ( F==F1 )
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0x14)
	BRNE _0x7
; 0000 0080                 {
; 0000 0081                 F=F2;
	LDI  R30,LOW(33)
	RJMP _0x9F
; 0000 0082                 }
; 0000 0083           else
_0x7:
; 0000 0084                 {
; 0000 0085                 if ( F==F2 )
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0x21)
	BRNE _0x9
; 0000 0086                       {
; 0000 0087                       F=F3;
	LDI  R30,LOW(55)
	RJMP _0x9F
; 0000 0088                       }
; 0000 0089                 else
_0x9:
; 0000 008A                       {
; 0000 008B                       if ( F==F3 )
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0x37)
	BRNE _0xB
; 0000 008C                             {
; 0000 008D                             F=F4;
	LDI  R30,LOW(77)
	RJMP _0x9F
; 0000 008E                             }
; 0000 008F                       else
_0xB:
; 0000 0090                             {
; 0000 0091                             F=F1;
	LDI  R30,LOW(20)
_0x9F:
	STS  _F,R30
; 0000 0092                             }
; 0000 0093                       }
; 0000 0094 
; 0000 0095                 }
; 0000 0096           SET_RF_Channel(F);
	RCALL SUBOPT_0x1
	RCALL _SET_RF_Channel
; 0000 0097           if (tim0_ov20>12) { FileSafe();  tim0_ov20=0;    }
	LDI  R30,LOW(12)
	CP   R30,R9
	BRSH _0xD
	RCALL _FileSafe
	CLR  R9
; 0000 0098 
; 0000 0099           }
_0xD:
; 0000 009A 
; 0000 009B       }
_0x6:
; 0000 009C 
; 0000 009D }
_0x3:
	RJMP _0xA0
;
;// Timer1 output compare A interrupt service routine
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)
; 0000 00A1 {
_timer1_compa_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00A2 // Place your code here     //   !!!
; 0000 00A3 
; 0000 00A4 n++;
	INC  R10
; 0000 00A5 
; 0000 00A6 if (n==1)
	LDI  R30,LOW(1)
	CP   R30,R10
	BRNE _0xE
; 0000 00A7   {
; 0000 00A8   TCCR1B=0;
	RCALL SUBOPT_0x2
; 0000 00A9   TCNT1=0;
; 0000 00AA   Out_K1=0;
	CBI  0x15,0
; 0000 00AB   OCR1A=Kanal[1];
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
; 0000 00AC   Out_K2=1;
	SBI  0x15,1
; 0000 00AD   TCCR1B=2;
	RCALL SUBOPT_0x5
; 0000 00AE   }
; 0000 00AF 
; 0000 00B0 if (n==2)
_0xE:
	LDI  R30,LOW(2)
	CP   R30,R10
	BRNE _0x13
; 0000 00B1   {
; 0000 00B2   TCCR1B=0;
	RCALL SUBOPT_0x2
; 0000 00B3   TCNT1=0;
; 0000 00B4   Out_K2=0;
	CBI  0x15,1
; 0000 00B5   Out_K3=1;
	SBI  0x15,2
; 0000 00B6   OCR1A=Kanal[2];
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
; 0000 00B7   TCCR1B=2;
; 0000 00B8   }
; 0000 00B9 
; 0000 00BA if (n==3)
_0x13:
	LDI  R30,LOW(3)
	CP   R30,R10
	BRNE _0x18
; 0000 00BB   {
; 0000 00BC   TCCR1B=0;
	RCALL SUBOPT_0x2
; 0000 00BD   TCNT1=0;
; 0000 00BE   Out_K3=0;
	CBI  0x15,2
; 0000 00BF   Out_K4=1;
	SBI  0x15,3
; 0000 00C0   OCR1A=Kanal[3];
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x7
; 0000 00C1   TCCR1B=2;
; 0000 00C2   }
; 0000 00C3 
; 0000 00C4 if (n==4)
_0x18:
	LDI  R30,LOW(4)
	CP   R30,R10
	BRNE _0x1D
; 0000 00C5   {
; 0000 00C6   TCCR1B=0;
	RCALL SUBOPT_0x2
; 0000 00C7   TCNT1=0;
; 0000 00C8   Out_K4=0;
	CBI  0x15,3
; 0000 00C9   Out_K5=1;
	SBI  0x15,4
; 0000 00CA   OCR1A=Kanal[4];
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x7
; 0000 00CB   TCCR1B=2;
; 0000 00CC   }
; 0000 00CD 
; 0000 00CE if (n==5)
_0x1D:
	LDI  R30,LOW(5)
	CP   R30,R10
	BRNE _0x22
; 0000 00CF   {
; 0000 00D0   TCCR1B=0;
	RCALL SUBOPT_0x2
; 0000 00D1   TCNT1=0;
; 0000 00D2   Out_K5=0;
	CBI  0x15,4
; 0000 00D3   Out_K6=1;
	SBI  0x15,5
; 0000 00D4   OCR1A=Kanal[5];
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x7
; 0000 00D5   TCCR1B=2;
; 0000 00D6   }
; 0000 00D7 
; 0000 00D8 if (n==6)
_0x22:
	LDI  R30,LOW(6)
	CP   R30,R10
	BRNE _0x27
; 0000 00D9   {
; 0000 00DA   TCCR1B=0;
	RCALL SUBOPT_0x2
; 0000 00DB   TCNT1=0;
; 0000 00DC   Out_K6=0;
	CBI  0x15,5
; 0000 00DD   Out_K7=1;
	SBI  0x12,0
; 0000 00DE   OCR1A=Kanal[6];
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x7
; 0000 00DF   TCCR1B=2;
; 0000 00E0   }
; 0000 00E1 
; 0000 00E2 if (n==7)
_0x27:
	LDI  R30,LOW(7)
	CP   R30,R10
	BRNE _0x2C
; 0000 00E3   {
; 0000 00E4   TCCR1B=0;
	RCALL SUBOPT_0x2
; 0000 00E5   TCNT1=0;
; 0000 00E6   Out_K7=0;
	CBI  0x12,0
; 0000 00E7   Out_K8=1;
	SBI  0x12,1
; 0000 00E8   OCR1A=Kanal[7];
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x7
; 0000 00E9   TCCR1B=2;
; 0000 00EA   }
; 0000 00EB 
; 0000 00EC if (n==8)
_0x2C:
	LDI  R30,LOW(8)
	CP   R30,R10
	BRNE _0x31
; 0000 00ED   {
; 0000 00EE   TCCR1B=0;
	RCALL SUBOPT_0x2
; 0000 00EF   TCNT1=0;
; 0000 00F0   Out_K8=0;
	CBI  0x12,1
; 0000 00F1 
; 0000 00F2   }
; 0000 00F3 
; 0000 00F4 
; 0000 00F5 }
_0x31:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;// Timer2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 00F9 {
_timer2_ovf_isr:
	RCALL SUBOPT_0x0
; 0000 00FA // Place your code here
; 0000 00FB 
; 0000 00FC tim2_ov++;
	INC  R11
; 0000 00FD 
; 0000 00FE if ( tim2_ov>=63 )  //  2 ms
	LDI  R30,LOW(63)
	CP   R11,R30
	BRLO _0x34
; 0000 00FF       {
; 0000 0100       tim2_ov=0;
	CLR  R11
; 0000 0101       n=0;
	CLR  R10
; 0000 0102       Out_Kanal();
	RCALL _Out_Kanal
; 0000 0103       TCCR2=0x00;
	RCALL SUBOPT_0xD
; 0000 0104       TCNT2=0x00;
; 0000 0105       }
; 0000 0106 
; 0000 0107 }
_0x34:
_0xA0:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;// SPI functions
;#include <spi.h>
;
;
;
;
;void SET_POWER_UP(void)
; 0000 0110 {
_SET_POWER_UP:
; 0000 0111 CSN=0;
	CBI  0x18,2
; 0000 0112 spi(0x20);
	LDI  R26,LOW(32)
	RCALL _spi
; 0000 0113 spi(0x0B);
	LDI  R26,LOW(11)
	RCALL _spi
; 0000 0114 CSN=1;
	RJMP _0x2080002
; 0000 0115 
; 0000 0116 }
;
;
;
;void SET_RF_Channel(unsigned char a)
; 0000 011B {
_SET_RF_Channel:
; 0000 011C CSN=0;
	ST   -Y,R26
;	a -> Y+0
	CBI  0x18,2
; 0000 011D spi(0x25);
	LDI  R26,LOW(37)
	RCALL _spi
; 0000 011E spi(a);   //  spi(0x02);  //  2- 
	LD   R26,Y
	RCALL SUBOPT_0xE
; 0000 011F CSN=1;
; 0000 0120 //CSN=1;
; 0000 0121 }
	RJMP _0x2080001
;
;
;void Reset_IRQ( void )  // All
; 0000 0125 {
_Reset_IRQ:
; 0000 0126 CSN=0;
	CBI  0x18,2
; 0000 0127 spi(0x27);
	LDI  R26,LOW(39)
	RCALL _spi
; 0000 0128 spi(0x70);  //
	LDI  R26,LOW(112)
	RCALL _spi
; 0000 0129 CSN=1;
	RJMP _0x2080002
; 0000 012A }
;
;
;void init_nRF( void )
; 0000 012E {
_init_nRF:
; 0000 012F 
; 0000 0130 //  bit PRIM_RX=1 , enable CRC , IRQ-RX_DR
; 0000 0131         CSN=0;
	CBI  0x18,2
; 0000 0132         spi(0x20);
	LDI  R26,LOW(32)
	RCALL SUBOPT_0xF
; 0000 0133         spi(0x3F);
; 0000 0134         CSN=1;
; 0000 0135 
; 0000 0136                 //  EN_RXADDR enable all
; 0000 0137         CSN=0;
	CBI  0x18,2
; 0000 0138         spi(0x22);
	LDI  R26,LOW(34)
	RCALL SUBOPT_0xF
; 0000 0139         spi(0x3F);
; 0000 013A         CSN=1;
; 0000 013B 
; 0000 013C                 //  EN_AA enable all
; 0000 013D         CSN=0;
	CBI  0x18,2
; 0000 013E         spi(0x21);
	LDI  R26,LOW(33)
	RCALL SUBOPT_0xF
; 0000 013F         spi(0x3F);
; 0000 0140         CSN=1;
; 0000 0141                   //   0x31
; 0000 0142 
; 0000 0143                 //  RX_PW_P0  = 32
; 0000 0144         CSN=0;
	CBI  0x18,2
; 0000 0145         spi(0x31);
	LDI  R26,LOW(49)
	RCALL _spi
; 0000 0146         spi(0x20);
	LDI  R26,LOW(32)
	RCALL SUBOPT_0xE
; 0000 0147         //spi(0x15);   //  21 bytes
; 0000 0148         CSN=1;
; 0000 0149 
; 0000 014A 
; 0000 014B         //  SET TX_ADDR    5 byte lengh
; 0000 014C         CSN=0;
	CBI  0x18,2
; 0000 014D         spi(0x30);
	LDI  R26,LOW(48)
	RCALL SUBOPT_0x10
; 0000 014E         spi(0xE7);
	RCALL SUBOPT_0x10
; 0000 014F         spi(0xE7);
	RCALL SUBOPT_0x10
; 0000 0150         spi(0xE7);
	RCALL SUBOPT_0x10
; 0000 0151         spi(0xE7);
	RCALL SUBOPT_0x10
; 0000 0152         spi(0xE7);
	RCALL SUBOPT_0xE
; 0000 0153         CSN=1;
; 0000 0154 
; 0000 0155 
; 0000 0156 
; 0000 0157         //  SET RX_ADDR    5 byte lengh
; 0000 0158         CSN=0;
	CBI  0x18,2
; 0000 0159         spi(0x2A);
	LDI  R26,LOW(42)
	RCALL SUBOPT_0x10
; 0000 015A         spi(0xE7);
	RCALL SUBOPT_0x10
; 0000 015B         spi(0xE7);
	RCALL SUBOPT_0x10
; 0000 015C         spi(0xE7);
	RCALL SUBOPT_0x10
; 0000 015D         spi(0xE7);
	RCALL SUBOPT_0x10
; 0000 015E         spi(0xE7);
	RCALL SUBOPT_0xE
; 0000 015F         CSN=1;
; 0000 0160 
; 0000 0161 
; 0000 0162         //  Enable auto ackn.
; 0000 0163         CSN=0;
	CBI  0x18,2
; 0000 0164         spi(0x22);
	LDI  R26,LOW(34)
	RCALL SUBOPT_0xF
; 0000 0165         spi(0x3F);
; 0000 0166         CSN=1;
; 0000 0167 
; 0000 0168 
; 0000 0169         //  Setup Retr
; 0000 016A         CSN=0;
	CBI  0x18,2
; 0000 016B         spi(0x24);
	LDI  R26,LOW(36)
	RCALL _spi
; 0000 016C         spi(0x33);  //  Wait 1 ms befor retransmit  ,  try 3 retransmit
	LDI  R26,LOW(51)
	RCALL SUBOPT_0xE
; 0000 016D         CSN=1;
; 0000 016E 
; 0000 016F 
; 0000 0170         //  SET RF Channel
; 0000 0171      //   SET_RF_Channel(20);
; 0000 0172 
; 0000 0173 
; 0000 0174 
; 0000 0175         //  SET  RF Speed and Power
; 0000 0176         CSN=0;
	CBI  0x18,2
; 0000 0177         spi(0x26);
	LDI  R26,LOW(38)
	RCALL _spi
; 0000 0178         spi(0x26);  //  256 kbit/s  0 dBm
	LDI  R26,LOW(38)
	RCALL _spi
; 0000 0179         CSN=1;
	RJMP _0x2080002
; 0000 017A 
; 0000 017B }
;
;
;
;void ReadBuffer(void)
; 0000 0180 {
_ReadBuffer:
; 0000 0181 
; 0000 0182 CSN=0;
	CBI  0x18,2
; 0000 0183 spi(0x61);   //    
	LDI  R26,LOW(97)
	RCALL _spi
; 0000 0184 for (i=0;i<32;i++) data[i]=spi(0);
	CLR  R5
_0x68:
	LDI  R30,LOW(32)
	CP   R5,R30
	BRSH _0x69
	MOV  R30,R5
	LDI  R31,0
	SUBI R30,LOW(-_data)
	SBCI R31,HIGH(-_data)
	PUSH R31
	PUSH R30
	LDI  R26,LOW(0)
	RCALL _spi
	POP  R26
	POP  R27
	ST   X,R30
	INC  R5
	RJMP _0x68
_0x69:
; 0000 0185 PORTB.2=1;
_0x2080002:
	SBI  0x18,2
; 0000 0186 
; 0000 0187 }
	RET
;
;
;void Out_Kanal(void) //    
; 0000 018B {
_Out_Kanal:
; 0000 018C n=0;
	CLR  R10
; 0000 018D OCR1A=Kanal[0];
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x4
; 0000 018E TCNT1=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
; 0000 018F TCCR1B=0x02;
	RCALL SUBOPT_0x5
; 0000 0190 
; 0000 0191 Out_K1=1;
	SBI  0x15,0
; 0000 0192 
; 0000 0193 #asm("wdr")
	wdr
; 0000 0194 
; 0000 0195 }
	RET
;
;
;void FileSafe(void)  //    
; 0000 0199 {
_FileSafe:
; 0000 019A Kanal[0]=E_F_Kanal[0];
	LDI  R26,LOW(_E_F_Kanal)
	LDI  R27,HIGH(_E_F_Kanal)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x12
; 0000 019B Kanal[1]=E_F_Kanal[1];
	__POINTW2MN _E_F_Kanal,2
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x13
; 0000 019C Kanal[2]=E_F_Kanal[2];
	__POINTW2MN _E_F_Kanal,4
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x14
; 0000 019D Kanal[3]=E_F_Kanal[3];
	__POINTW2MN _E_F_Kanal,6
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x15
; 0000 019E Kanal[4]=E_F_Kanal[4];
	__POINTW2MN _E_F_Kanal,8
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x16
; 0000 019F Kanal[5]=E_F_Kanal[5];
	__POINTW2MN _E_F_Kanal,10
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x17
; 0000 01A0 Kanal[6]=E_F_Kanal[6];
	__POINTW2MN _E_F_Kanal,12
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x18
; 0000 01A1 Kanal[7]=E_F_Kanal[7];
	__POINTW2MN _E_F_Kanal,14
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x19
; 0000 01A2 
; 0000 01A3 }
	RET
;
;void Safe(void)  //  
; 0000 01A6 {
_Safe:
; 0000 01A7 F_Kanal[0]=Kanal[0];
	RCALL SUBOPT_0x11
	STS  _F_Kanal,R30
	STS  _F_Kanal+1,R31
; 0000 01A8 F_Kanal[1]=Kanal[1];
	RCALL SUBOPT_0x3
	__PUTW1MN _F_Kanal,2
; 0000 01A9 F_Kanal[2]=Kanal[2];
	RCALL SUBOPT_0x6
	__PUTW1MN _F_Kanal,4
; 0000 01AA F_Kanal[3]=Kanal[3];
	RCALL SUBOPT_0x8
	__PUTW1MN _F_Kanal,6
; 0000 01AB F_Kanal[4]=Kanal[4];
	RCALL SUBOPT_0x9
	__PUTW1MN _F_Kanal,8
; 0000 01AC F_Kanal[5]=Kanal[5];
	RCALL SUBOPT_0xA
	__PUTW1MN _F_Kanal,10
; 0000 01AD F_Kanal[6]=Kanal[6];
	RCALL SUBOPT_0xB
	__PUTW1MN _F_Kanal,12
; 0000 01AE F_Kanal[7]=Kanal[7];
	RCALL SUBOPT_0xC
	__PUTW1MN _F_Kanal,14
; 0000 01AF FS_On=1;
	LDI  R30,LOW(1)
	STS  _FS_On,R30
; 0000 01B0 
; 0000 01B1 }
	RET
;
;
;void Safe1(void)  //  
; 0000 01B5 {
_Safe1:
; 0000 01B6 E_F_Kanal[0]=F_Kanal[0];
	LDS  R30,_F_Kanal
	LDS  R31,_F_Kanal+1
	LDI  R26,LOW(_E_F_Kanal)
	LDI  R27,HIGH(_E_F_Kanal)
	RCALL __EEPROMWRW
; 0000 01B7 E_F_Kanal[1]=F_Kanal[1];
	__POINTW2MN _E_F_Kanal,2
	__GETW1MN _F_Kanal,2
	RCALL __EEPROMWRW
; 0000 01B8 E_F_Kanal[2]=F_Kanal[2];
	__POINTW2MN _E_F_Kanal,4
	__GETW1MN _F_Kanal,4
	RCALL __EEPROMWRW
; 0000 01B9 E_F_Kanal[3]=F_Kanal[3];
	__POINTW2MN _E_F_Kanal,6
	__GETW1MN _F_Kanal,6
	RCALL __EEPROMWRW
; 0000 01BA E_F_Kanal[4]=F_Kanal[4];
	__POINTW2MN _E_F_Kanal,8
	__GETW1MN _F_Kanal,8
	RCALL __EEPROMWRW
; 0000 01BB E_F_Kanal[5]=F_Kanal[5];
	__POINTW2MN _E_F_Kanal,10
	__GETW1MN _F_Kanal,10
	RCALL __EEPROMWRW
; 0000 01BC E_F_Kanal[6]=F_Kanal[6];
	__POINTW2MN _E_F_Kanal,12
	__GETW1MN _F_Kanal,12
	RCALL __EEPROMWRW
; 0000 01BD E_F_Kanal[7]=F_Kanal[7];
	__POINTW2MN _E_F_Kanal,14
	__GETW1MN _F_Kanal,14
	RCALL __EEPROMWRW
; 0000 01BE 
; 0000 01BF }
	RET
;
;
;
;
;
;
;void Yes_IRQ(void) //  
; 0000 01C7 {
_Yes_IRQ:
; 0000 01C8 
; 0000 01C9 TCNT2=0;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 01CA TCCR2=0x01;   //  start timer 2      63    
	LDI  R30,LOW(1)
	OUT  0x25,R30
; 0000 01CB TCNT0=0;    //   timer 0
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 01CC ReadBuffer();
	RCALL _ReadBuffer
; 0000 01CD Reset_IRQ();
	RCALL _Reset_IRQ
; 0000 01CE if ( data[0]==Code_1&&data[1]==Code_2 )
	LDS  R26,_data
	CPI  R26,LOW(0x21)
	BRNE _0x6F
	__GETB2MN _data,1
	CPI  R26,LOW(0x2D)
	BREQ _0x70
_0x6F:
	RJMP _0x6E
_0x70:
; 0000 01CF     {
; 0000 01D0     RX_Fail=0; //  
	LDI  R30,LOW(0)
	STS  _RX_Fail,R30
; 0000 01D1     tim0_ov1=0;
	CLR  R6
; 0000 01D2     tim0_ov=0; //       1 us
	CLR  R7
; 0000 01D3 
; 0000 01D4     K_H=data[6];
	__GETB1MN _data,6
	RCALL SUBOPT_0x1A
; 0000 01D5     K_L=data[7];
	__GETB1MN _data,7
	RCALL SUBOPT_0x1B
; 0000 01D6     Kanal[0]=(K_H<<8) + K_L;
	RCALL SUBOPT_0x12
; 0000 01D7     if (Kanal[0]>2200) Kanal[0]=2200;
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	BRLO _0x71
	LDI  R30,LOW(2200)
	LDI  R31,HIGH(2200)
	RCALL SUBOPT_0x12
; 0000 01D8     if (Kanal[0]<800) Kanal[0]=800;
_0x71:
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1E
	BRSH _0x72
	LDI  R30,LOW(800)
	LDI  R31,HIGH(800)
	RCALL SUBOPT_0x12
; 0000 01D9 
; 0000 01DA     K_H=data[8];
_0x72:
	__GETB1MN _data,8
	RCALL SUBOPT_0x1A
; 0000 01DB     K_L=data[9];
	__GETB1MN _data,9
	RCALL SUBOPT_0x1B
; 0000 01DC     Kanal[1]=(K_H<<8) + K_L;
	RCALL SUBOPT_0x13
; 0000 01DD     if (Kanal[1]>2200) Kanal[1]=2200;
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1D
	BRLO _0x73
	__POINTW1MN _Kanal,2
	RCALL SUBOPT_0x20
; 0000 01DE     if (Kanal[1]<800) Kanal[1]=800;
_0x73:
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1E
	BRSH _0x74
	__POINTW1MN _Kanal,2
	RCALL SUBOPT_0x21
; 0000 01DF 
; 0000 01E0     K_H=data[10];
_0x74:
	__GETB1MN _data,10
	RCALL SUBOPT_0x1A
; 0000 01E1     K_L=data[11];
	__GETB1MN _data,11
	RCALL SUBOPT_0x1B
; 0000 01E2     Kanal[2]=(K_H<<8) + K_L;
	RCALL SUBOPT_0x14
; 0000 01E3     if (Kanal[2]>2200) Kanal[2]=2200;
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x1D
	BRLO _0x75
	__POINTW1MN _Kanal,4
	RCALL SUBOPT_0x20
; 0000 01E4     if (Kanal[2]<800) Kanal[2]=800;
_0x75:
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x1E
	BRSH _0x76
	__POINTW1MN _Kanal,4
	RCALL SUBOPT_0x21
; 0000 01E5 
; 0000 01E6     K_H=data[12];
_0x76:
	__GETB1MN _data,12
	RCALL SUBOPT_0x1A
; 0000 01E7     K_L=data[13];
	__GETB1MN _data,13
	RCALL SUBOPT_0x1B
; 0000 01E8     Kanal[3]=(K_H<<8) + K_L;
	RCALL SUBOPT_0x15
; 0000 01E9     if (Kanal[3]>2200) Kanal[3]=2200;
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x1D
	BRLO _0x77
	__POINTW1MN _Kanal,6
	RCALL SUBOPT_0x20
; 0000 01EA     if (Kanal[3]<800) Kanal[3]=800;
_0x77:
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x1E
	BRSH _0x78
	__POINTW1MN _Kanal,6
	RCALL SUBOPT_0x21
; 0000 01EB 
; 0000 01EC     K_H=data[14];
_0x78:
	__GETB1MN _data,14
	RCALL SUBOPT_0x1A
; 0000 01ED     K_L=data[15];
	__GETB1MN _data,15
	RCALL SUBOPT_0x1B
; 0000 01EE     Kanal[4]=(K_H<<8) + K_L;
	RCALL SUBOPT_0x16
; 0000 01EF     if (Kanal[4]>2200) Kanal[4]=2200;
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x1D
	BRLO _0x79
	__POINTW1MN _Kanal,8
	RCALL SUBOPT_0x20
; 0000 01F0     if (Kanal[4]<800) Kanal[4]=800;
_0x79:
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x1E
	BRSH _0x7A
	__POINTW1MN _Kanal,8
	RCALL SUBOPT_0x21
; 0000 01F1 
; 0000 01F2     K_H=data[16];
_0x7A:
	__GETB1MN _data,16
	RCALL SUBOPT_0x1A
; 0000 01F3     K_L=data[17];
	__GETB1MN _data,17
	RCALL SUBOPT_0x1B
; 0000 01F4     Kanal[5]=(K_H<<8) + K_L;
	RCALL SUBOPT_0x17
; 0000 01F5     if (Kanal[5]>2200) Kanal[5]=2200;
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x1D
	BRLO _0x7B
	__POINTW1MN _Kanal,10
	RCALL SUBOPT_0x20
; 0000 01F6     if (Kanal[5]<800) Kanal[5]=800;
_0x7B:
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x1E
	BRSH _0x7C
	__POINTW1MN _Kanal,10
	RCALL SUBOPT_0x21
; 0000 01F7 
; 0000 01F8     K_H=data[18];
_0x7C:
	__GETB1MN _data,18
	RCALL SUBOPT_0x1A
; 0000 01F9     K_L=data[19];
	__GETB1MN _data,19
	RCALL SUBOPT_0x1B
; 0000 01FA     Kanal[6]=(K_H<<8) + K_L;
	RCALL SUBOPT_0x18
; 0000 01FB     if (Kanal[6]>2200) Kanal[6]=2200;
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x1D
	BRLO _0x7D
	__POINTW1MN _Kanal,12
	RCALL SUBOPT_0x20
; 0000 01FC     if (Kanal[6]<800) Kanal[6]=800;
_0x7D:
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x1E
	BRSH _0x7E
	__POINTW1MN _Kanal,12
	RCALL SUBOPT_0x21
; 0000 01FD 
; 0000 01FE     K_H=data[20];
_0x7E:
	__GETB1MN _data,20
	RCALL SUBOPT_0x1A
; 0000 01FF     K_L=data[21];
	__GETB1MN _data,21
	RCALL SUBOPT_0x1B
; 0000 0200     Kanal[7]=(K_H<<8) + K_L;
	RCALL SUBOPT_0x19
; 0000 0201     if (Kanal[7]>2200) Kanal[7]=2200;
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x1D
	BRLO _0x7F
	__POINTW1MN _Kanal,14
	RCALL SUBOPT_0x20
; 0000 0202     if (Kanal[7]<800) Kanal[7]=800;
_0x7F:
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x1E
	BRSH _0x80
	__POINTW1MN _Kanal,14
	RCALL SUBOPT_0x21
; 0000 0203 
; 0000 0204 
; 0000 0205     if (Input_FS) { Safe(); LED=0;  }
_0x80:
	SBIC 0x10,2
	RJMP _0x81
	RCALL _Safe
	CBI  0x12,5
; 0000 0206     else
	RJMP _0x84
_0x81:
; 0000 0207       {
; 0000 0208       if(FS_On)
	LDS  R30,_FS_On
	CPI  R30,0
	BREQ _0x85
; 0000 0209             {
; 0000 020A             LED=0;
	RCALL SUBOPT_0x28
; 0000 020B             delay_ms(300);
; 0000 020C             LED=1;
	SBI  0x12,5
; 0000 020D             delay_ms(300);
	LDI  R26,LOW(300)
	LDI  R27,HIGH(300)
	RCALL _delay_ms
; 0000 020E             LED=0;
	RCALL SUBOPT_0x28
; 0000 020F             delay_ms(300);
; 0000 0210             Safe1();
	RCALL _Safe1
; 0000 0211             FS_On=0;
	LDI  R30,LOW(0)
	STS  _FS_On,R30
; 0000 0212             LED=1;
	SBI  0x12,5
; 0000 0213             }
; 0000 0214       LED=1;
_0x85:
	SBI  0x12,5
; 0000 0215       }
_0x84:
; 0000 0216 
; 0000 0217     }
; 0000 0218 
; 0000 0219 
; 0000 021A }
_0x6E:
	RET
;
;
;// Declare your global variables here
;
;void main(void)
; 0000 0220 {
_main:
; 0000 0221 // Declare your local variables here
; 0000 0222 
; 0000 0223 // Input/Output Ports initialization
; 0000 0224 // Port B initialization
; 0000 0225 // Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=In
; 0000 0226 // State7=P State6=P State5=0 State4=T State3=0 State2=0 State1=0 State0=P
; 0000 0227 PORTB=0xC1;
	LDI  R30,LOW(193)
	OUT  0x18,R30
; 0000 0228 DDRB=0x2E;
	LDI  R30,LOW(46)
	OUT  0x17,R30
; 0000 0229 
; 0000 022A // Port C initialization
; 0000 022B // Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 022C // State6=P State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 022D PORTC=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
; 0000 022E DDRC=0x3F;
	LDI  R30,LOW(63)
	OUT  0x14,R30
; 0000 022F 
; 0000 0230 // Port D initialization
; 0000 0231 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=In Func1=Out Func0=Out
; 0000 0232 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=P State1=0 State0=0
; 0000 0233 PORTD=0x04;
	LDI  R30,LOW(4)
	OUT  0x12,R30
; 0000 0234 DDRD=0xFB;
	LDI  R30,LOW(251)
	OUT  0x11,R30
; 0000 0235 
; 0000 0236 // Timer/Counter 0 initialization
; 0000 0237 // Clock source: System Clock
; 0000 0238 // Clock value: Timer 0 Stopped
; 0000 0239 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 023A TCNT0=0x00;
	OUT  0x32,R30
; 0000 023B 
; 0000 023C // Timer/Counter 1 initialization
; 0000 023D // Clock source: System Clock
; 0000 023E // Clock value: Timer1 Stopped
; 0000 023F // Mode: Normal top=0xFFFF
; 0000 0240 // OC1A output: Discon.
; 0000 0241 // OC1B output: Discon.
; 0000 0242 // Noise Canceler: Off
; 0000 0243 // Input Capture on Falling Edge
; 0000 0244 // Timer1 Overflow Interrupt: Off
; 0000 0245 // Input Capture Interrupt: Off
; 0000 0246 // Compare A Match Interrupt: On
; 0000 0247 // Compare B Match Interrupt: Off
; 0000 0248 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0249 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 024A TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 024B TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 024C ICR1H=0x00;
	OUT  0x27,R30
; 0000 024D ICR1L=0x00;
	OUT  0x26,R30
; 0000 024E OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 024F OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0250 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0251 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0252 
; 0000 0253 // Timer/Counter 2 initialization
; 0000 0254 // Clock source: System Clock
; 0000 0255 // Clock value: Timer2 Stopped
; 0000 0256 // Mode: Normal top=0xFF
; 0000 0257 // OC2 output: Disconnected
; 0000 0258 ASSR=0x00;
	OUT  0x22,R30
; 0000 0259 TCCR2=0x00;
	RCALL SUBOPT_0xD
; 0000 025A TCNT2=0x00;
; 0000 025B OCR2=0x00;
	LDI  R30,LOW(0)
	OUT  0x23,R30
; 0000 025C 
; 0000 025D // External Interrupt(s) initialization
; 0000 025E // INT0: Off
; 0000 025F // INT1: Off
; 0000 0260 MCUCR=0x00;
	OUT  0x35,R30
; 0000 0261 
; 0000 0262 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0263 TIMSK=0x51;
	LDI  R30,LOW(81)
	OUT  0x39,R30
; 0000 0264 
; 0000 0265 // USART initialization
; 0000 0266 // USART disabled
; 0000 0267 UCSRB=0x00;
	LDI  R30,LOW(0)
	OUT  0xA,R30
; 0000 0268 
; 0000 0269 // Analog Comparator initialization
; 0000 026A // Analog Comparator: Off
; 0000 026B // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 026C ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 026D SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 026E 
; 0000 026F // ADC initialization
; 0000 0270 // ADC disabled
; 0000 0271 ADCSRA=0x00;
	OUT  0x6,R30
; 0000 0272 
; 0000 0273 // SPI initialization
; 0000 0274 // SPI Type: Master
; 0000 0275 // SPI Clock Rate: 2000,000 kHz
; 0000 0276 // SPI Clock Phase: Cycle Start
; 0000 0277 // SPI Clock Polarity: Low
; 0000 0278 // SPI Data Order: MSB First
; 0000 0279 //SPCR=0x50;
; 0000 027A //SPSR=0x00;
; 0000 027B // SPI initialization
; 0000 027C // SPI Type: Master
; 0000 027D // SPI Clock Rate: 2*2000,000 kHz
; 0000 027E // SPI Clock Phase: Cycle Start
; 0000 027F // SPI Clock Polarity: Low
; 0000 0280 // SPI Data Order: MSB First
; 0000 0281 SPCR=0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
; 0000 0282 SPSR=0x01;
	LDI  R30,LOW(1)
	OUT  0xE,R30
; 0000 0283 
; 0000 0284 // TWI initialization
; 0000 0285 // TWI disabled
; 0000 0286 TWCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x36,R30
; 0000 0287 
; 0000 0288 // Watchdog Timer initialization
; 0000 0289 // Watchdog Timer Prescaler: OSC/2048k
; 0000 028A #pragma optsize-
; 0000 028B WDTCR=0x1F;
	LDI  R30,LOW(31)
	OUT  0x21,R30
; 0000 028C WDTCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x21,R30
; 0000 028D #ifdef _OPTIMIZE_SIZE_
; 0000 028E #pragma optsize+
; 0000 028F #endif
; 0000 0290 
; 0000 0291 // Global enable interrupts
; 0000 0292 #asm("sei")
	sei
; 0000 0293 
; 0000 0294     delay_ms(200);
	LDI  R26,LOW(200)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0295     CE=0;
	CBI  0x18,1
; 0000 0296     tim0_ov=0;
	CLR  R7
; 0000 0297     tim0_ov1=0;
	CLR  R6
; 0000 0298     tim0_ov20=0;
	CLR  R9
; 0000 0299     tim1_ov=0;
	CLR  R8
; 0000 029A     tim2_ov=0;
	CLR  R11
; 0000 029B 
; 0000 029C 
; 0000 029D     init_nRF();
	RCALL _init_nRF
; 0000 029E 
; 0000 029F     n=0;
	CLR  R10
; 0000 02A0     FS_On=0;
	LDI  R30,LOW(0)
	STS  _FS_On,R30
; 0000 02A1 
; 0000 02A2     if (E_F_Kanal[6]==0xFFFF) //    
	__POINTW2MN _E_F_Kanal,12
	RCALL __EEPROMRDW
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x92
; 0000 02A3           {
; 0000 02A4           for(k=0;k<8;k++) E_F_Kanal[k]=1500;
	CLR  R4
_0x94:
	LDI  R30,LOW(8)
	CP   R4,R30
	BRSH _0x95
	MOV  R30,R4
	LDI  R26,LOW(_E_F_Kanal)
	LDI  R27,HIGH(_E_F_Kanal)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	RCALL __EEPROMWRW
	INC  R4
	RJMP _0x94
_0x95:
; 0000 02A5 }
; 0000 02A6 
; 0000 02A7 
; 0000 02A8       // Place your code here
; 0000 02A9       SET_POWER_UP();
_0x92:
	RCALL _SET_POWER_UP
; 0000 02AA 
; 0000 02AB       CE=1;     //  Start RX
	SBI  0x18,1
; 0000 02AC       delay_us(130);
	__DELAY_USW 260
; 0000 02AD 
; 0000 02AE       SET_RF_Channel(F1);
	LDI  R26,LOW(20)
	RCALL _SET_RF_Channel
; 0000 02AF 
; 0000 02B0       RX_Fail=0;
	LDI  R30,LOW(0)
	STS  _RX_Fail,R30
; 0000 02B1       RX_OK=0;
	CLR  R13
; 0000 02B2       RX_OK1=0;
	CLR  R12
; 0000 02B3 
; 0000 02B4       TCCR0=0x02;  //  1 MHz   !!!
	LDI  R30,LOW(2)
	OUT  0x33,R30
; 0000 02B5       TCCR1B=0x00;  //  0 MHz
	LDI  R30,LOW(0)
	OUT  0x2E,R30
; 0000 02B6 
; 0000 02B7       while (1)   //     
_0x98:
; 0000 02B8               {
; 0000 02B9               while (IRQ)  delay_us(1);
_0x9B:
	SBIS 0x16,0
	RJMP _0x9D
	__DELAY_USB 3
	RJMP _0x9B
_0x9D:
; 0000 02BA Yes_IRQ();
	RCALL _Yes_IRQ
; 0000 02BB 
; 0000 02BC               }
	RJMP _0x98
; 0000 02BD 
; 0000 02BE }
_0x9E:
	RJMP _0x9E
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_spi:
	ST   -Y,R26
	LD   R30,Y
	OUT  0xF,R30
_0x2020003:
	SBIS 0xE,7
	RJMP _0x2020003
	IN   R30,0xF
_0x2080001:
	ADIW R28,1
	RET

	.CSEG

	.CSEG

	.DSEG
_data:
	.BYTE 0x20
_F:
	.BYTE 0x1
_RX_Fail:
	.BYTE 0x1
_FS_On:
	.BYTE 0x1
_Kanal:
	.BYTE 0x10
_K_H:
	.BYTE 0x2
_K_L:
	.BYTE 0x2
_F_Kanal:
	.BYTE 0x10

	.ESEG
_E_F_Kanal:
	.BYTE 0x10

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x0:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	LDS  R26,_F
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	OUT  0x2E,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	__GETW1MN _Kanal,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	OUT  0x2A+1,R31
	OUT  0x2A,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(2)
	OUT  0x2E,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	__GETW1MN _Kanal,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7:
	RCALL SUBOPT_0x4
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	__GETW1MN _Kanal,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	__GETW1MN _Kanal,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	__GETW1MN _Kanal,10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	__GETW1MN _Kanal,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	__GETW1MN _Kanal,14
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(0)
	OUT  0x25,R30
	OUT  0x24,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xE:
	RCALL _spi
	SBI  0x18,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xF:
	RCALL _spi
	LDI  R26,LOW(63)
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x10:
	RCALL _spi
	LDI  R26,LOW(231)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	LDS  R30,_Kanal
	LDS  R31,_Kanal+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x12:
	STS  _Kanal,R30
	STS  _Kanal+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	__PUTW1MN _Kanal,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	__PUTW1MN _Kanal,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	__PUTW1MN _Kanal,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x16:
	__PUTW1MN _Kanal,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	__PUTW1MN _Kanal,10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	__PUTW1MN _Kanal,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	__PUTW1MN _Kanal,14
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x1A:
	LDI  R31,0
	STS  _K_H,R30
	STS  _K_H+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:89 WORDS
SUBOPT_0x1B:
	LDI  R31,0
	STS  _K_L,R30
	STS  _K_L+1,R31
	LDS  R31,_K_H
	LDI  R30,LOW(0)
	LDS  R26,_K_L
	LDS  R27,_K_L+1
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	LDS  R26,_Kanal
	LDS  R27,_Kanal+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x1D:
	CPI  R26,LOW(0x899)
	LDI  R30,HIGH(0x899)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x1E:
	CPI  R26,LOW(0x320)
	LDI  R30,HIGH(0x320)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	__GETW2MN _Kanal,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x20:
	LDI  R26,LOW(2200)
	LDI  R27,HIGH(2200)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x21:
	LDI  R26,LOW(800)
	LDI  R27,HIGH(800)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x22:
	__GETW2MN _Kanal,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	__GETW2MN _Kanal,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x24:
	__GETW2MN _Kanal,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x25:
	__GETW2MN _Kanal,10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	__GETW2MN _Kanal,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x27:
	__GETW2MN _Kanal,14
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x28:
	CBI  0x12,5
	LDI  R26,LOW(300)
	LDI  R27,HIGH(300)
	RJMP _delay_ms


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
