/*****************************************************

         !!!!!

This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : RX nRF24L01+
Version : 
Date    : 10.11.2013
Author  : 
Company : 
Comments: 
RX nRF24L01+


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256



 nRF24L01+
 

 nRF     Mega
 MOSI---MOSI
 MISO---MISO
  SCK---SCK
CSN     PORTB.2
CE      PORTB.1
IRQ     PORTB.0

LED       PORTD.5   "-"
Save FileSave  PORTD.2
Servo K1       PORTC.0
Servo K2       PORTC.1











*****************************************************/

#include <mega8.h>

#include <delay.h>

#include <stdio.h>

#define   CSN   PORTB.2
#define   CE    PORTB.1
#define   IRQ   PINB.0
#define   F1    20   
#define   F2    33
#define   F3    55
#define   F4    77
#define   LED        PORTD.5  //  ->>  "-"
#define   Input_FS   !PIND.2
#define   Out_K1     PORTC.0  
#define   Out_K2     PORTC.1
#define   Out_K3     PORTC.2
#define   Out_K4     PORTC.3
#define   Out_K5     PORTC.4
#define   Out_K6     PORTC.5
#define   Out_K7     PORTD.0
#define   Out_K8     PORTD.1

#define   Code_1      33
#define   Code_2      45

unsigned char i, k ;
unsigned char data[32];
unsigned char tim0_ov, tim0_ov1,  tim0_ov20, tim1_ov, tim2_ov ; //  tim0_ov2,
unsigned char n;

unsigned char RX_OK,  RX_OK1;
unsigned char F; // F1, F2, F3, F4;  //   
unsigned char  RX_Fail;    //  

unsigned char FS_On; //                

unsigned int Kanal[8], K_H, K_L ;   //   
unsigned int F_Kanal[8];
eeprom unsigned int E_F_Kanal[8];

void Safe(void);
void FileSafe(void);
void Out_Kanal(void);
void SET_RF_Channel(unsigned char a);


// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
//  1 MHz   !!!
//    22 ,      filesafe
//  1 Mhz  22.016 ms == 86 timer0_ovf

tim0_ov++;
if ( tim0_ov >= 86 )   //  22 ms                   //      200 ===   //  51,2 ms
      {
      tim0_ov=0;
      tim0_ov1++;
      
      LED=0;
      
      n=0;
      Out_Kanal();  //    
        
      if (tim0_ov1>10)  // 220 ms
          { 
          tim0_ov1=0;
          tim0_ov20++;
          if ( F==F1 )
                {
                F=F2;
                }
          else
                {
                if ( F==F2 )
                      {
                      F=F3;
                      }
                else
                      {
                      if ( F==F3 )
                            {
                            F=F4;
                            }
                      else
                            {
                            F=F1;
                            }      
                      }
                
                }
          SET_RF_Channel(F);
          if (tim0_ov20>12) { FileSafe();  tim0_ov20=0;    }
          
          }
          
      }

}

// Timer1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
// Place your code here     //   !!!

n++;
      
if (n==1)
  {
  TCCR1B=0;
  TCNT1=0;                    
  Out_K1=0;                  
  OCR1A=Kanal[1];
  Out_K2=1;
  TCCR1B=2;
  }
          
if (n==2)
  {
  TCCR1B=0;
  TCNT1=0;   
  Out_K2=0;
  Out_K3=1;
  OCR1A=Kanal[2];
  TCCR1B=2;
  }   
 
if (n==3)
  {
  TCCR1B=0;
  TCNT1=0;
  Out_K3=0;
  Out_K4=1;
  OCR1A=Kanal[3];
  TCCR1B=2;
  }

if (n==4)
  {
  TCCR1B=0;
  TCNT1=0;
  Out_K4=0;
  Out_K5=1;
  OCR1A=Kanal[4];
  TCCR1B=2;
  }

if (n==5)
  {
  TCCR1B=0;
  TCNT1=0;
  Out_K5=0;
  Out_K6=1;
  OCR1A=Kanal[5];
  TCCR1B=2;
  }

if (n==6)
  {
  TCCR1B=0;
  TCNT1=0;
  Out_K6=0;
  Out_K7=1;
  OCR1A=Kanal[6];
  TCCR1B=2;
  }

if (n==7)
  {
  TCCR1B=0;
  TCNT1=0;
  Out_K7=0;
  Out_K8=1;
  OCR1A=Kanal[7];
  TCCR1B=2;
  }

if (n==8)
  {
  TCCR1B=0;
  TCNT1=0;
  Out_K8=0;
  
  }
  

}

// Timer2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Place your code here

tim2_ov++;

if ( tim2_ov>=63 )  //  2 ms
      {
      tim2_ov=0;
      n=0;
      Out_Kanal();
      TCCR2=0x00;
      TCNT2=0x00;
      }

}

// SPI functions
#include <spi.h>




void SET_POWER_UP(void)
{ 
CSN=0;
spi(0x20);
spi(0x0B);    
CSN=1;

}



void SET_RF_Channel(unsigned char a)
{
CSN=0;
spi(0x25);
spi(a);   //  spi(0x02);  //  2- 
CSN=1;
//CSN=1;
}


void Reset_IRQ( void )  // All
{
CSN=0;
spi(0x27);
spi(0x70);  //  
CSN=1;
}


void init_nRF( void )
{

//  bit PRIM_RX=1 , enable CRC , IRQ-RX_DR
        CSN=0;
        spi(0x20);
        spi(0x3F);
        CSN=1;
        
                //  EN_RXADDR enable all
        CSN=0;
        spi(0x22);
        spi(0x3F);
        CSN=1;
        
                //  EN_AA enable all
        CSN=0;
        spi(0x21);
        spi(0x3F);
        CSN=1;
                  //   0x31
        
                //  RX_PW_P0  = 32
        CSN=0;
        spi(0x31);
        spi(0x20);
        //spi(0x15);   //  21 bytes
        CSN=1;
        

        //  SET TX_ADDR    5 byte lengh
        CSN=0;
        spi(0x30);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        CSN=1;
        
        
        
        //  SET RX_ADDR    5 byte lengh      
        CSN=0;
        spi(0x2A);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        CSN=1;
        
        
        //  Enable auto ackn.
        CSN=0;
        spi(0x22);
        spi(0x3F);
        CSN=1;
        
        
        //  Setup Retr
        CSN=0;
        spi(0x24);
        spi(0x33);  //  Wait 1 ms befor retransmit  ,  try 3 retransmit
        CSN=1;
        
        
        //  SET RF Channel
     //   SET_RF_Channel(20);
        
        
        
        //  SET  RF Speed and Power
        CSN=0;
        spi(0x26);
        spi(0x26);  //  256 kbit/s  0 dBm
        CSN=1;
        
}



void ReadBuffer(void)
{
    
CSN=0;
spi(0x61);   //     
for (i=0;i<32;i++) data[i]=spi(0);
CSN=1;      
                  
}


void Out_Kanal(void) //    
{
n=0;
OCR1A=Kanal[0];
TCNT1=0;
TCCR1B=0x02;

Out_K1=1;

#asm("wdr")

}


void FileSafe(void)  //    
{
Kanal[0]=E_F_Kanal[0];
Kanal[1]=E_F_Kanal[1];
Kanal[2]=E_F_Kanal[2];
Kanal[3]=E_F_Kanal[3];
Kanal[4]=E_F_Kanal[4];
Kanal[5]=E_F_Kanal[5];
Kanal[6]=E_F_Kanal[6];
Kanal[7]=E_F_Kanal[7];

}

void Safe(void)  //  
{
F_Kanal[0]=Kanal[0];
F_Kanal[1]=Kanal[1];
F_Kanal[2]=Kanal[2];
F_Kanal[3]=Kanal[3];
F_Kanal[4]=Kanal[4];
F_Kanal[5]=Kanal[5];
F_Kanal[6]=Kanal[6];
F_Kanal[7]=Kanal[7];
FS_On=1;

}


void Safe1(void)  //  
{
E_F_Kanal[0]=F_Kanal[0];
E_F_Kanal[1]=F_Kanal[1];
E_F_Kanal[2]=F_Kanal[2];
E_F_Kanal[3]=F_Kanal[3];
E_F_Kanal[4]=F_Kanal[4];
E_F_Kanal[5]=F_Kanal[5];
E_F_Kanal[6]=F_Kanal[6];
E_F_Kanal[7]=F_Kanal[7];

}






void Yes_IRQ(void) //  
{

TCNT2=0;
TCCR2=0x01;   //  start timer 2      63    
TCNT0=0;    //   timer 0
ReadBuffer();  
Reset_IRQ();
if ( data[0]==Code_1&&data[1]==Code_2 )
    {
    RX_Fail=0; //  
    tim0_ov1=0;
    tim0_ov=0; //       1 us
    
    K_H=data[6];
    K_L=data[7];
    Kanal[0]=(K_H<<8) + K_L;
    if (Kanal[0]>2200) Kanal[0]=2200;
    if (Kanal[0]<800) Kanal[0]=800;
                        
    K_H=data[8];  
    K_L=data[9];   
    Kanal[1]=(K_H<<8) + K_L;
    if (Kanal[1]>2200) Kanal[1]=2200;
    if (Kanal[1]<800) Kanal[1]=800;    
                        
    K_H=data[10];
    K_L=data[11];
    Kanal[2]=(K_H<<8) + K_L;
    if (Kanal[2]>2200) Kanal[2]=2200;
    if (Kanal[2]<800) Kanal[2]=800;
                            
    K_H=data[12];
    K_L=data[13];
    Kanal[3]=(K_H<<8) + K_L;
    if (Kanal[3]>2200) Kanal[3]=2200;
    if (Kanal[3]<800) Kanal[3]=800;
                            
    K_H=data[14];
    K_L=data[15];
    Kanal[4]=(K_H<<8) + K_L;
    if (Kanal[4]>2200) Kanal[4]=2200;
    if (Kanal[4]<800) Kanal[4]=800;
                            
    K_H=data[16];
    K_L=data[17];
    Kanal[5]=(K_H<<8) + K_L;
    if (Kanal[5]>2200) Kanal[5]=2200;
    if (Kanal[5]<800) Kanal[5]=800;
                            
    K_H=data[18];
    K_L=data[19];
    Kanal[6]=(K_H<<8) + K_L;
    if (Kanal[6]>2200) Kanal[6]=2200;
    if (Kanal[6]<800) Kanal[6]=800;
        
    K_H=data[20];
    K_L=data[21];
    Kanal[7]=(K_H<<8) + K_L;
    if (Kanal[7]>2200) Kanal[7]=2200;
    if (Kanal[7]<800) Kanal[7]=800;
    
    
    if (Input_FS) { Safe(); LED=0;  }     
    else 
      { 
      if(FS_On) 
            { 
            LED=0;
            delay_ms(300);
            LED=1;
            delay_ms(300);
            LED=0;
            delay_ms(300); 
            Safe1(); 
            FS_On=0;
            LED=1; 
            }
      LED=1;      
      }
     
    }

    
}


// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=In 
// State7=P State6=P State5=0 State4=T State3=0 State2=0 State1=0 State0=P 
PORTB=0xC1;
DDRB=0x2E;

// Port C initialization
// Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State6=P State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTC=0x40;
DDRC=0x3F;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=In Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=P State1=0 State0=0 
PORTD=0x04;
DDRD=0xFB;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x51;

// USART initialization
// USART disabled
UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 2000,000 kHz
// SPI Clock Phase: Cycle Start
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
//SPCR=0x50;
//SPSR=0x00;
// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 2*2000,000 kHz
// SPI Clock Phase: Cycle Start
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
SPCR=0x50;
SPSR=0x01;

// TWI initialization
// TWI disabled
TWCR=0x00;

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/2048k
#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Global enable interrupts
#asm("sei")

    delay_ms(200);
    CE=0;
    tim0_ov=0; 
    tim0_ov1=0;  
    tim0_ov20=0; 
    tim1_ov=0; 
    tim2_ov=0;

    
    init_nRF();
    
    n=0;
    FS_On=0;

    if (E_F_Kanal[6]==0xFFFF) //    
          {
          for(k=0;k<8;k++) E_F_Kanal[k]=1500;
          }


      // Place your code here
      SET_POWER_UP();
      
      CE=1;     //  Start RX
      delay_us(130);
      
      SET_RF_Channel(F1);
        
      RX_Fail=0;
      RX_OK=0;
      RX_OK1=0;
      
      TCCR0=0x02;  //  1 MHz   !!!
      TCCR1B=0x00;  //  0 MHz   
      
      while (1)   //     
              {
              while (IRQ)  delay_us(1); 
              Yes_IRQ();
                
              }

}
