
;CodeVisionAVR C Compiler V2.05.6 
;(C) Copyright 1998-2012 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Polar=R5
	.DEF _Begin=R4
	.DEF _Begin1=R7
	.DEF _Begin2=R6
	.DEF _Pause=R9
	.DEF _Pulse=R8
	.DEF _data_ready=R11

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP _timer1_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;
;     !!!!!
;
;This program was produced by the
;CodeWizardAVR V2.05.3 Standard
;Automatic Program Generator
; Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : TX nRF24L01+
;Version :
;Date    : 10.11.2013
;Author  :
;Company :
;Comments:
;TX nRF24L01+
;
;
;Chip type               : ATmega8
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;
;
;nRF24L01+
;
;                nRF     Mega
;                MOSI---MOSI
;                MISO---MISO
;                SCK---SCK
;
;
;
;
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <string.h>
;#include <spi.h>
;
;#define uint unsigned int
;#define uchar unsigned char
;
;#define   CSN   PORTD.7     //  MOSI PB3
;#define   CE    PORTD.6     //  MISO PB4
;#define   IRQ   PIND.5      //  SCK PB5
;#define   In    PIND.2     //  INT0
;
;
;#define F1  20
;#define F2  33
;#define F3  55
;#define F4  77
;#define Code_1    33
;#define Code_2    45
;
;unsigned char  data[32];
;
;unsigned char Polar ;    // 1 == positive    0 == negative
;unsigned char Begin, Begin1, Begin2,   Pause ;
;unsigned char Pulse, data_ready ;
;
;unsigned int Kanal[8], TKanal[8];
;
;
;
;
;void Start_TX(void)
; 0000 0049 {

	.CSEG
_Start_TX:
; 0000 004A CE=1;
	SBI  0x12,6
; 0000 004B delay_us(20);
	__DELAY_USB 53
; 0000 004C CE=0;
	CBI  0x12,6
; 0000 004D }
	RET
;
;
;
;void POWER_UP( void )
; 0000 0052 {
_POWER_UP:
; 0000 0053 CSN=0;
	CBI  0x12,7
; 0000 0054 spi(0x20);
	LDI  R26,LOW(32)
	RCALL _spi
; 0000 0055 spi(0x5A);  //
	LDI  R26,LOW(90)
	RJMP _0x2040003
; 0000 0056 CSN=1;
; 0000 0057 }
;
;
;
;
;
;void RESET_PRIM_RX( void )
; 0000 005E {
_RESET_PRIM_RX:
; 0000 005F CSN=0;
	CBI  0x12,7
; 0000 0060 spi(0x20);
	LDI  R26,LOW(32)
	RCALL _spi
; 0000 0061 spi(0x5C);
	LDI  R26,LOW(92)
_0x2040003:
	RCALL _spi
; 0000 0062 CSN=1;
	SBI  0x12,7
; 0000 0063 }
	RET
;
;void SET_TX_ADDR(unsigned char a)
; 0000 0066 {
_SET_TX_ADDR:
; 0000 0067 CSN=0;
	ST   -Y,R26
;	a -> Y+0
	CBI  0x12,7
; 0000 0068 spi(0x30);
	LDI  R26,LOW(48)
	RCALL SUBOPT_0x0
; 0000 0069 spi(0xE7);
	RCALL SUBOPT_0x0
; 0000 006A spi(0xE7);
	RCALL SUBOPT_0x0
; 0000 006B spi(0xE7);
	RCALL SUBOPT_0x0
; 0000 006C spi(0xE7);
	RCALL SUBOPT_0x1
; 0000 006D spi(a);
; 0000 006E CSN=1;
; 0000 006F }
	RJMP _0x2040001
;
;void SET_RX_ADDR(unsigned char a)
; 0000 0072 {
_SET_RX_ADDR:
; 0000 0073 CSN=0;
	ST   -Y,R26
;	a -> Y+0
	CBI  0x12,7
; 0000 0074 spi(0x2A);
	LDI  R26,LOW(42)
	RCALL SUBOPT_0x0
; 0000 0075 spi(0xE7);
	RCALL SUBOPT_0x0
; 0000 0076 spi(0xE7);
	RCALL SUBOPT_0x0
; 0000 0077 spi(0xE7);
	RCALL SUBOPT_0x0
; 0000 0078 spi(0xE7);
	RCALL SUBOPT_0x1
; 0000 0079 spi(a);
; 0000 007A CSN=1;
; 0000 007B }
	RJMP _0x2040001
;
;void SET_RF_Channel(unsigned char a)
; 0000 007E {
_SET_RF_Channel:
; 0000 007F CSN=0;
	ST   -Y,R26
;	a -> Y+0
	CBI  0x12,7
; 0000 0080 spi(0x25);
	LDI  R26,LOW(37)
	RCALL SUBOPT_0x1
; 0000 0081 spi(a);
; 0000 0082 CSN=1;
; 0000 0083 }
	RJMP _0x2040001
;
;
;
;
;
;void init2_nRF( void )
; 0000 008A {
_init2_nRF:
; 0000 008B 
; 0000 008C RESET_PRIM_RX();
	RCALL _RESET_PRIM_RX
; 0000 008D 
; 0000 008E 
; 0000 008F //  Addres width 5 bytes
; 0000 0090         CSN=0;
	CBI  0x12,7
; 0000 0091         spi(0x23);
	LDI  R26,LOW(35)
	RCALL _spi
; 0000 0092         spi(0x03);
	LDI  R26,LOW(3)
	RCALL SUBOPT_0x2
; 0000 0093         CSN=1;
; 0000 0094 
; 0000 0095 // Disable autoRetransmit
; 0000 0096 CSN=0;
; 0000 0097 spi(0x24);
	LDI  R26,LOW(36)
	RCALL _spi
; 0000 0098 spi(0x20);  //  !!!!!
	LDI  R26,LOW(32)
	RCALL SUBOPT_0x2
; 0000 0099 CSN=1;
; 0000 009A 
; 0000 009B //  SET  RF Speed and Power
; 0000 009C CSN=0;
; 0000 009D spi(0x26);
	LDI  R26,LOW(38)
	RCALL _spi
; 0000 009E spi(0x26);  //  256 kbit/s  0 dBm
	LDI  R26,LOW(38)
	RCALL _spi
; 0000 009F CSN=1;
	SBI  0x12,7
; 0000 00A0 
; 0000 00A1 SET_TX_ADDR(0xE7);
	LDI  R26,LOW(231)
	RCALL _SET_TX_ADDR
; 0000 00A2 
; 0000 00A3 SET_RX_ADDR(0xE7);
	LDI  R26,LOW(231)
	RCALL _SET_RX_ADDR
; 0000 00A4 
; 0000 00A5 SET_RF_Channel(F1);
	LDI  R26,LOW(20)
	RCALL _SET_RF_Channel
; 0000 00A6 
; 0000 00A7 }
	RET
;
;
;
;void Begin_TX1(unsigned char a)
; 0000 00AC {
_Begin_TX1:
; 0000 00AD char i;
; 0000 00AE 
; 0000 00AF 
; 0000 00B0 
; 0000 00B1     init2_nRF();  //  150 us
	ST   -Y,R26
	ST   -Y,R17
;	a -> Y+1
;	i -> R17
	RCALL _init2_nRF
; 0000 00B2 
; 0000 00B3 
; 0000 00B4     SET_RF_Channel(a);
	RCALL SUBOPT_0x3
; 0000 00B5 
; 0000 00B6     POWER_UP();
; 0000 00B7 
; 0000 00B8     CSN=0;
; 0000 00B9     spi(0x3D);
; 0000 00BA     spi(0x01);
; 0000 00BB     CSN=1;
; 0000 00BC 
; 0000 00BD     //  Send Data to TX
; 0000 00BE     CSN=0;
; 0000 00BF     spi(0xB0);
	LDI  R26,LOW(176)
	RCALL _spi
; 0000 00C0     for (i=0;i<32;i++) spi(data[i]);
	LDI  R17,LOW(0)
_0x2E:
	CPI  R17,32
	BRSH _0x2F
	RCALL SUBOPT_0x4
	SUBI R17,-1
	RJMP _0x2E
_0x2F:
; 0000 00C1 PORTD.7     =1;
	RJMP _0x2040002
; 0000 00C2 
; 0000 00C3     //  Start Transmitting      CE   PORTB.3
; 0000 00C4     Start_TX();
; 0000 00C5 
; 0000 00C6 }
;
;void Begin_TX2(unsigned char a)
; 0000 00C9 {
_Begin_TX2:
; 0000 00CA     //init2_nRF();
; 0000 00CB char i;
; 0000 00CC 
; 0000 00CD     SET_RF_Channel(a);
	ST   -Y,R26
	ST   -Y,R17
;	a -> Y+1
;	i -> R17
	RCALL SUBOPT_0x3
; 0000 00CE 
; 0000 00CF     POWER_UP();
; 0000 00D0 
; 0000 00D1     CSN=0;
; 0000 00D2     spi(0x3D);
; 0000 00D3     spi(0x01);
; 0000 00D4     CSN=1;
; 0000 00D5 
; 0000 00D6     //  Send Data to TX
; 0000 00D7     CSN=0;
; 0000 00D8     spi(0xB0);
	LDI  R26,LOW(176)
	RCALL _spi
; 0000 00D9     for (i=0;i<32;i++) spi(data[i]);
	LDI  R17,LOW(0)
_0x39:
	CPI  R17,32
	BRSH _0x3A
	RCALL SUBOPT_0x4
	SUBI R17,-1
	RJMP _0x39
_0x3A:
; 0000 00DA PORTD.7     =1;
_0x2040002:
	SBI  0x12,7
; 0000 00DB 
; 0000 00DC     //  Start Transmitting      CE   PORTB.3
; 0000 00DD     Start_TX();
	RCALL _Start_TX
; 0000 00DE 
; 0000 00DF }
	LDD  R17,Y+0
	ADIW R28,2
	RET
;
;
;
;
;void Copy_K(void)
; 0000 00E5 {
_Copy_K:
; 0000 00E6 char i;
; 0000 00E7 
; 0000 00E8 for (i=0;i<8;i++)
	ST   -Y,R17
;	i -> R17
	LDI  R17,LOW(0)
_0x3E:
	CPI  R17,8
	BRSH _0x3F
; 0000 00E9       {
; 0000 00EA       if (TKanal[i]>=2200) TKanal[i]=2200;
	RCALL SUBOPT_0x5
	RCALL __GETW1P
	CPI  R30,LOW(0x898)
	LDI  R26,HIGH(0x898)
	CPC  R31,R26
	BRLO _0x40
	RCALL SUBOPT_0x5
	LDI  R30,LOW(2200)
	LDI  R31,HIGH(2200)
	RCALL SUBOPT_0x6
; 0000 00EB       if (TKanal[i]<=800)  TKanal[i]=800;
_0x40:
	RCALL SUBOPT_0x5
	RCALL __GETW1P
	CPI  R30,LOW(0x321)
	LDI  R26,HIGH(0x321)
	CPC  R31,R26
	BRSH _0x41
	RCALL SUBOPT_0x5
	LDI  R30,LOW(800)
	LDI  R31,HIGH(800)
	RCALL SUBOPT_0x6
; 0000 00EC       }
_0x41:
	SUBI R17,-1
	RJMP _0x3E
_0x3F:
; 0000 00ED 
; 0000 00EE for (i=0;i<8;i++)  Kanal[i]=TKanal[i];
	LDI  R17,LOW(0)
_0x43:
	CPI  R17,8
	BRSH _0x44
	MOV  R30,R17
	LDI  R26,LOW(_Kanal)
	LDI  R27,HIGH(_Kanal)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	RCALL SUBOPT_0x5
	RCALL __GETW1P
	MOVW R26,R0
	RCALL SUBOPT_0x6
	SUBI R17,-1
	RJMP _0x43
_0x44:
; 0000 00F0 data[6]=Kanal[0]>>8;
	LDS  R30,_Kanal+1
	__PUTB1MN _data,6
; 0000 00F1 data[7]=Kanal[0]&255;
	LDS  R30,_Kanal
	__PUTB1MN _data,7
; 0000 00F2 
; 0000 00F3 data[8]=Kanal[1]>>8;
	__GETB1MN _Kanal,3
	__PUTB1MN _data,8
; 0000 00F4 data[9]=Kanal[1]&255;
	__GETB1MN _Kanal,2
	__PUTB1MN _data,9
; 0000 00F5 
; 0000 00F6 data[10]=Kanal[2]>>8;
	__GETB1MN _Kanal,5
	__PUTB1MN _data,10
; 0000 00F7 data[11]=Kanal[2]&255;
	__GETB1MN _Kanal,4
	__PUTB1MN _data,11
; 0000 00F8 
; 0000 00F9 data[12]=Kanal[3]>>8;
	__GETB1MN _Kanal,7
	__PUTB1MN _data,12
; 0000 00FA data[13]=Kanal[3]&255;
	__GETB1MN _Kanal,6
	__PUTB1MN _data,13
; 0000 00FB 
; 0000 00FC data[14]=Kanal[4]>>8;
	__GETB1MN _Kanal,9
	__PUTB1MN _data,14
; 0000 00FD data[15]=Kanal[4]&255;
	__GETB1MN _Kanal,8
	__PUTB1MN _data,15
; 0000 00FE 
; 0000 00FF data[16]=Kanal[5]>>8;
	__GETB1MN _Kanal,11
	__PUTB1MN _data,16
; 0000 0100 data[17]=Kanal[5]&255;
	__GETB1MN _Kanal,10
	__PUTB1MN _data,17
; 0000 0101 
; 0000 0102 data[18]=Kanal[6]>>8;
	__GETB1MN _Kanal,13
	__PUTB1MN _data,18
; 0000 0103 data[19]=Kanal[6]&255;
	__GETB1MN _Kanal,12
	__PUTB1MN _data,19
; 0000 0104 
; 0000 0105 data[20]=Kanal[7]>>8;
	__GETB1MN _Kanal,15
	__PUTB1MN _data,20
; 0000 0106 data[21]=Kanal[7]&255;
	__GETB1MN _Kanal,14
	__PUTB1MN _data,21
; 0000 0107 
; 0000 0108 
; 0000 0109 data_ready=1;
	LDI  R30,LOW(1)
	MOV  R11,R30
; 0000 010A 
; 0000 010B }
	LD   R17,Y+
	RET
;
;
;
;
;
;// External Interrupt 0 service routine
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 0113 {
_ext_int0_isr:
	RCALL SUBOPT_0x7
; 0000 0114 // Place your code here
; 0000 0115 
; 0000 0116 
; 0000 0117 
; 0000 0118 if (Begin==0)
	BREQ PC+2
	RJMP _0x45
; 0000 0119     {
; 0000 011A     if (Pause) { Pulse=0; Pause=0;  }
	TST  R9
	BREQ _0x46
	CLR  R8
	CLR  R9
; 0000 011B         if (Pulse==0)
_0x46:
	TST  R8
	BRNE _0x47
; 0000 011C             {
; 0000 011D             TCNT1=0; TCNT2=0;
	RCALL SUBOPT_0x8
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 011E             #asm("wdr")
	wdr
; 0000 011F             Begin_TX1(F1);     //    !!!!!!!!
	LDI  R26,LOW(20)
	RCALL _Begin_TX1
; 0000 0120             }
; 0000 0121         if (Pulse==1)
_0x47:
	LDI  R30,LOW(1)
	CP   R30,R8
	BRNE _0x48
; 0000 0122             {
; 0000 0123             TKanal[0]=TCNT1; TCNT1=0;
	RCALL SUBOPT_0x9
	STS  _TKanal,R30
	STS  _TKanal+1,R31
	RCALL SUBOPT_0x8
; 0000 0124 
; 0000 0125             }
; 0000 0126         if (Pulse==2)
_0x48:
	LDI  R30,LOW(2)
	CP   R30,R8
	BRNE _0x49
; 0000 0127             {
; 0000 0128             TKanal[1]=TCNT1; TCNT1=0;
	__POINTW2MN _TKanal,2
	RCALL SUBOPT_0xA
; 0000 0129             Begin_TX2(F2);    //    !!!!!!!!
	LDI  R26,LOW(33)
	RCALL _Begin_TX2
; 0000 012A             }
; 0000 012B         if (Pulse==3)
_0x49:
	LDI  R30,LOW(3)
	CP   R30,R8
	BRNE _0x4A
; 0000 012C             {
; 0000 012D             TKanal[2]=TCNT1; TCNT1=0;
	__POINTW2MN _TKanal,4
	RCALL SUBOPT_0xA
; 0000 012E 
; 0000 012F             }
; 0000 0130         if (Pulse==4)
_0x4A:
	LDI  R30,LOW(4)
	CP   R30,R8
	BRNE _0x4B
; 0000 0131             {
; 0000 0132             TKanal[3]=TCNT1; TCNT1=0;
	__POINTW2MN _TKanal,6
	RCALL SUBOPT_0xA
; 0000 0133             Begin_TX2(F3);    //    !!!!!!!!
	LDI  R26,LOW(55)
	RCALL _Begin_TX2
; 0000 0134             }
; 0000 0135         if (Pulse==5)
_0x4B:
	LDI  R30,LOW(5)
	CP   R30,R8
	BRNE _0x4C
; 0000 0136             {
; 0000 0137             TKanal[4]=TCNT1; TCNT1=0;
	__POINTW2MN _TKanal,8
	RCALL SUBOPT_0xA
; 0000 0138 
; 0000 0139             }
; 0000 013A         if (Pulse==6)
_0x4C:
	LDI  R30,LOW(6)
	CP   R30,R8
	BRNE _0x4D
; 0000 013B             {
; 0000 013C             TKanal[5]=TCNT1; TCNT1=0;
	__POINTW2MN _TKanal,10
	RCALL SUBOPT_0xA
; 0000 013D             Begin_TX2(F4);    //    !!!!!!!!
	LDI  R26,LOW(77)
	RCALL _Begin_TX2
; 0000 013E             }
; 0000 013F         if (Pulse==7)
_0x4D:
	LDI  R30,LOW(7)
	CP   R30,R8
	BRNE _0x4E
; 0000 0140             {
; 0000 0141             TKanal[6]=TCNT1; TCNT1=0;
	__POINTW2MN _TKanal,12
	RCALL SUBOPT_0xA
; 0000 0142 
; 0000 0143             }
; 0000 0144         if (Pulse==8)
_0x4E:
	LDI  R30,LOW(8)
	CP   R30,R8
	BRNE _0x4F
; 0000 0145             {
; 0000 0146             TKanal[7]=TCNT1; TCNT1=0;
	__POINTW2MN _TKanal,14
	RCALL SUBOPT_0xA
; 0000 0147 
; 0000 0148             }
; 0000 0149 
; 0000 014A 
; 0000 014B         Pulse++;
_0x4F:
	INC  R8
; 0000 014C 
; 0000 014D 
; 0000 014E     if (data_ready)
	TST  R11
	BREQ _0x50
; 0000 014F         {
; 0000 0150         data_ready=0;
	CLR  R11
; 0000 0151         }
; 0000 0152     }
_0x50:
; 0000 0153 else
	RJMP _0x51
_0x45:
; 0000 0154     {
; 0000 0155     TCNT1=0;
	RCALL SUBOPT_0x8
; 0000 0156 
; 0000 0157     }
_0x51:
; 0000 0158 
; 0000 0159 
; 0000 015A 
; 0000 015B }
	RJMP _0x5B
;
;// Timer1 output compare A interrupt service routine
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)
; 0000 015F {
_timer1_compa_isr:
	RCALL SUBOPT_0x7
; 0000 0160 // Place your code here
; 0000 0161 
; 0000 0162 if (Begin)   //       
	BREQ _0x52
; 0000 0163     {
; 0000 0164     if (In)
	SBIS 0x10,2
	RJMP _0x53
; 0000 0165         {
; 0000 0166         Polar=0;
	CLR  R5
; 0000 0167         MCUCR=0x02;
	LDI  R30,LOW(2)
	RJMP _0x5A
; 0000 0168         }
; 0000 0169     else
_0x53:
; 0000 016A         {
; 0000 016B         Polar=1;
	LDI  R30,LOW(1)
	MOV  R5,R30
; 0000 016C         MCUCR=0x03;
	LDI  R30,LOW(3)
_0x5A:
	OUT  0x35,R30
; 0000 016D         }
; 0000 016E         Begin=0;
	CLR  R4
; 0000 016F     }
; 0000 0170 
; 0000 0171 else    //   
	RJMP _0x55
_0x52:
; 0000 0172     {
; 0000 0173     Pulse=0;
	CLR  R8
; 0000 0174     Pause=1;
	LDI  R30,LOW(1)
	MOV  R9,R30
; 0000 0175     Copy_K();
	RCALL _Copy_K
; 0000 0176     }
_0x55:
; 0000 0177 }
_0x5B:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;// Timer2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 017B {
_timer2_ovf_isr:
; 0000 017C // Place your code here
; 0000 017D 
; 0000 017E 
; 0000 017F }
	RETI
;
;
;
;
;// SPI functions
;//#include <spi.h>
;
;// Declare your global variables here
;
;void main(void)
; 0000 018A {
_main:
; 0000 018B // Declare your local variables here
; 0000 018C 
; 0000 018D // Input/Output Ports initialization
; 0000 018E // Port B initialization
; 0000 018F // Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0190 // State7=T State6=T State5=0 State4=T State3=0 State2=0 State1=0 State0=0
; 0000 0191 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0192 DDRB=0x2F;
	LDI  R30,LOW(47)
	OUT  0x17,R30
; 0000 0193 
; 0000 0194 // Port C initialization
; 0000 0195 // Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0196 // State6=P State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 0197 PORTC=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
; 0000 0198 DDRC=0x3F;
	LDI  R30,LOW(63)
	OUT  0x14,R30
; 0000 0199 
; 0000 019A // Port D initialization
; 0000 019B // Func7=Out Func6=Out Func5=In Func4=Out Func3=Out Func2=In Func1=Out Func0=Out
; 0000 019C // State7=0 State6=0 State5=P State4=0 State3=0 State2=T State1=0 State0=0
; 0000 019D PORTD=0x20;
	LDI  R30,LOW(32)
	OUT  0x12,R30
; 0000 019E DDRD=0xDB;
	LDI  R30,LOW(219)
	OUT  0x11,R30
; 0000 019F 
; 0000 01A0 // Timer/Counter 0 initialization
; 0000 01A1 // Clock source: System Clock
; 0000 01A2 // Clock value: Timer 0 Stopped
; 0000 01A3 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 01A4 TCNT0=0x00;
	OUT  0x32,R30
; 0000 01A5 
; 0000 01A6 // Timer/Counter 1 initialization
; 0000 01A7 // Clock source: System Clock
; 0000 01A8 // Clock value: Timer1 Stopped
; 0000 01A9 // Mode: Normal top=0xFFFF
; 0000 01AA // OC1A output: Discon.
; 0000 01AB // OC1B output: Discon.
; 0000 01AC // Noise Canceler: Off
; 0000 01AD // Input Capture on Falling Edge
; 0000 01AE // Timer1 Overflow Interrupt: Off
; 0000 01AF // Input Capture Interrupt: Off
; 0000 01B0 // Compare A Match Interrupt: On
; 0000 01B1 // Compare B Match Interrupt: Off
; 0000 01B2 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 01B3 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 01B4 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 01B5 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 01B6 ICR1H=0x00;
	OUT  0x27,R30
; 0000 01B7 ICR1L=0x00;
	OUT  0x26,R30
; 0000 01B8 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 01B9 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 01BA OCR1BH=0x00;
	OUT  0x29,R30
; 0000 01BB OCR1BL=0x00;
	OUT  0x28,R30
; 0000 01BC 
; 0000 01BD // Timer/Counter 2 initialization
; 0000 01BE // Clock source: System Clock
; 0000 01BF // Clock value: Timer2 Stopped
; 0000 01C0 // Mode: Normal top=0xFF
; 0000 01C1 // OC2 output: Disconnected
; 0000 01C2 ASSR=0x00;
	OUT  0x22,R30
; 0000 01C3 TCCR2=0x00;
	OUT  0x25,R30
; 0000 01C4 TCNT2=0x00;
	OUT  0x24,R30
; 0000 01C5 OCR2=0x00;
	OUT  0x23,R30
; 0000 01C6 
; 0000 01C7 // External Interrupt(s) initialization
; 0000 01C8 // INT0: On
; 0000 01C9 // INT0 Mode: Any change
; 0000 01CA // INT1: Off
; 0000 01CB GICR|=0x40;
	IN   R30,0x3B
	ORI  R30,0x40
	OUT  0x3B,R30
; 0000 01CC MCUCR=0x01;
	LDI  R30,LOW(1)
	OUT  0x35,R30
; 0000 01CD GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
; 0000 01CE 
; 0000 01CF // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 01D0 TIMSK=0x50;
	LDI  R30,LOW(80)
	OUT  0x39,R30
; 0000 01D1 
; 0000 01D2 // USART initialization
; 0000 01D3 // USART disabled
; 0000 01D4 UCSRB=0x00;
	LDI  R30,LOW(0)
	OUT  0xA,R30
; 0000 01D5 
; 0000 01D6 // Analog Comparator initialization
; 0000 01D7 // Analog Comparator: Off
; 0000 01D8 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 01D9 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 01DA SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 01DB 
; 0000 01DC // ADC initialization
; 0000 01DD // ADC disabled
; 0000 01DE ADCSRA=0x00;
	OUT  0x6,R30
; 0000 01DF 
; 0000 01E0 // SPI initialization
; 0000 01E1 // SPI Type: Master
; 0000 01E2 // SPI Clock Rate: 2000,000 kHz
; 0000 01E3 // SPI Clock Phase: Cycle Start
; 0000 01E4 // SPI Clock Polarity: Low
; 0000 01E5 // SPI Data Order: MSB First
; 0000 01E6 //SPCR=0x50;
; 0000 01E7 //SPSR=0x00;
; 0000 01E8 // SPI initialization
; 0000 01E9 // SPI Type: Master
; 0000 01EA // SPI Clock Rate: 2*2000,000 kHz
; 0000 01EB // SPI Clock Phase: Cycle Start
; 0000 01EC // SPI Clock Polarity: Low
; 0000 01ED // SPI Data Order: MSB First
; 0000 01EE SPCR=0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
; 0000 01EF SPSR=0x01;
	LDI  R30,LOW(1)
	OUT  0xE,R30
; 0000 01F0 
; 0000 01F1 
; 0000 01F2 
; 0000 01F3 
; 0000 01F4 
; 0000 01F5 
; 0000 01F6 // TWI initialization
; 0000 01F7 // TWI disabled
; 0000 01F8 TWCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x36,R30
; 0000 01F9 
; 0000 01FA // Watchdog Timer initialization
; 0000 01FB // Watchdog Timer Prescaler: OSC/2048k
; 0000 01FC #pragma optsize-
; 0000 01FD WDTCR=0x1F;
	LDI  R30,LOW(31)
	OUT  0x21,R30
; 0000 01FE WDTCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x21,R30
; 0000 01FF #ifdef _OPTIMIZE_SIZE_
; 0000 0200 #pragma optsize+
; 0000 0201 #endif
; 0000 0202 
; 0000 0203 // Global enable interrupts
; 0000 0204 #asm("sei")
	sei
; 0000 0205 
; 0000 0206 
; 0000 0207 init2_nRF();
	RCALL _init2_nRF
; 0000 0208 
; 0000 0209 Polar=0;
	CLR  R5
; 0000 020A Begin1=0;
	CLR  R7
; 0000 020B Begin2=0;
	CLR  R6
; 0000 020C Begin=1;
	LDI  R30,LOW(1)
	MOV  R4,R30
; 0000 020D Pause=0;
	CLR  R9
; 0000 020E data_ready=0;
	CLR  R11
; 0000 020F 
; 0000 0210 data[0]=Code_1;
	LDI  R30,LOW(33)
	STS  _data,R30
; 0000 0211 data[1]=Code_2;
	LDI  R30,LOW(45)
	__PUTB1MN _data,1
; 0000 0212 data[2]=F1;           //   Kanal
	LDI  R30,LOW(20)
	__PUTB1MN _data,2
; 0000 0213 data[3]=F2;
	LDI  R30,LOW(33)
	__PUTB1MN _data,3
; 0000 0214 data[4]=F3;
	LDI  R30,LOW(55)
	__PUTB1MN _data,4
; 0000 0215 data[5]=F4;
	LDI  R30,LOW(77)
	__PUTB1MN _data,5
; 0000 0216 
; 0000 0217 
; 0000 0218 TCCR0=0x02;  //  1 
	LDI  R30,LOW(2)
	OUT  0x33,R30
; 0000 0219 
; 0000 021A TCCR1B=0x02;
	OUT  0x2E,R30
; 0000 021B OCR1A=2500;
	LDI  R30,LOW(2500)
	LDI  R31,HIGH(2500)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 021C 
; 0000 021D while (1)
_0x56:
; 0000 021E       {
; 0000 021F       // Place your code here
; 0000 0220       ;
; 0000 0221       }
	RJMP _0x56
; 0000 0222 }
_0x59:
	RJMP _0x59

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_spi:
	ST   -Y,R26
	LD   R30,Y
	OUT  0xF,R30
_0x2020003:
	SBIS 0xE,7
	RJMP _0x2020003
	IN   R30,0xF
_0x2040001:
	ADIW R28,1
	RET

	.DSEG
_data:
	.BYTE 0x20
_Kanal:
	.BYTE 0x10
_TKanal:
	.BYTE 0x10

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x0:
	RCALL _spi
	LDI  R26,LOW(231)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1:
	RCALL _spi
	LD   R26,Y
	RCALL _spi
	SBI  0x12,7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2:
	RCALL _spi
	SBI  0x12,7
	CBI  0x12,7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3:
	LDD  R26,Y+1
	RCALL _SET_RF_Channel
	RCALL _POWER_UP
	CBI  0x12,7
	LDI  R26,LOW(61)
	RCALL _spi
	LDI  R26,LOW(1)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4:
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_data)
	SBCI R31,HIGH(-_data)
	LD   R26,Z
	RJMP _spi

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x5:
	MOV  R30,R17
	LDI  R26,LOW(_TKanal)
	LDI  R27,HIGH(_TKanal)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x6:
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x7:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	TST  R4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x9:
	IN   R30,0x2C
	IN   R31,0x2C+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xA:
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x6
	RJMP SUBOPT_0x8


	.CSEG
__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

;END OF CODE MARKER
__END_OF_CODE:
