/*****************************************************

     !!!!!

This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : TX nRF24L01+
Version : 
Date    : 10.11.2013
Author  : 
Company : 
Comments: 
TX nRF24L01+


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256


nRF24L01+

                nRF     Mega           
                MOSI---MOSI    
                MISO---MISO    
                SCK---SCK     




*****************************************************/

#include <mega8.h>
#include <delay.h>
#include <string.h>
#include <spi.h>

#define uint unsigned int
#define uchar unsigned char

#define   CSN   PORTD.7     //  MOSI PB3
#define   CE    PORTD.6     //  MISO PB4
#define   IRQ   PIND.5      //  SCK PB5
#define   In    PIND.2     //  INT0


#define F1  20
#define F2  33
#define F3  55
#define F4  77
#define Code_1    33
#define Code_2    45

unsigned char  data[32];           

unsigned char Polar ;    // 1 == positive    0 == negative      
unsigned char Begin, Begin1, Begin2,   Pause ;  
unsigned char Pulse, data_ready ;

unsigned int Kanal[8], TKanal[8]; 




void Start_TX(void)
{
CE=1;
delay_us(20); 
CE=0;
}



void POWER_UP( void )  
{   
CSN=0;
spi(0x20);
spi(0x5A);  //  
CSN=1;
}





void RESET_PRIM_RX( void )   
{
CSN=0;
spi(0x20);
spi(0x5C);
CSN=1;
}

void SET_TX_ADDR(unsigned char a)
{
CSN=0;
spi(0x30);
spi(0xE7);
spi(0xE7);
spi(0xE7);
spi(0xE7);
spi(a);
CSN=1;
}

void SET_RX_ADDR(unsigned char a)
{
CSN=0;
spi(0x2A);
spi(0xE7);
spi(0xE7);
spi(0xE7);
spi(0xE7);
spi(a);
CSN=1;
}

void SET_RF_Channel(unsigned char a)
{
CSN=0;
spi(0x25);
spi(a);  
CSN=1;
}





void init2_nRF( void )  
{

RESET_PRIM_RX();


//  Addres width 5 bytes
        CSN=0;
        spi(0x23);
        spi(0x03);
        CSN=1;
        
// Disable autoRetransmit
CSN=0;
spi(0x24);
spi(0x20);  //  !!!!!
CSN=1;        
        
//  SET  RF Speed and Power
CSN=0;
spi(0x26);
spi(0x26);  //  256 kbit/s  0 dBm
CSN=1;

SET_TX_ADDR(0xE7);

SET_RX_ADDR(0xE7);                    
                    
SET_RF_Channel(F1);

}



void Begin_TX1(unsigned char a)
{
char i;


    
    init2_nRF();  //  150 us
    
    
    SET_RF_Channel(a);
    delay_us(200);
    POWER_UP();   
                      
    CSN=0;     
    spi(0x3D); 
    spi(0x01);
    CSN=1;
                          
    //  Send Data to TX 
    CSN=0;
    spi(0xB0); 
    for (i=0;i<32;i++) spi(data[i]); 
    CSN=1;
                    
    //  Start Transmitting      CE   PORTB.3 
    Start_TX();

}

void Begin_TX2(unsigned char a)
{
    //init2_nRF();
char i;
    
    SET_RF_Channel(a);
    delay_us(200);
    POWER_UP();   
                      
    CSN=0;     
    spi(0x3D); 
    spi(0x01);
    CSN=1;
                          
    //  Send Data to TX 
    CSN=0;
    spi(0xB0); 
    for (i=0;i<32;i++) spi(data[i]); 
    CSN=1;
                    
    //  Start Transmitting      CE   PORTB.3 
    Start_TX();

}




void Copy_K(void)
{
char i;  

for (i=0;i<8;i++)
      {
      if (TKanal[i]>=2200) TKanal[i]=2200;
      if (TKanal[i]<=800)  TKanal[i]=800; 
      }

for (i=0;i<8;i++)  Kanal[i]=TKanal[i];   

data[6]=Kanal[0]>>8;
data[7]=Kanal[0]&255;

data[8]=Kanal[1]>>8;
data[9]=Kanal[1]&255;
       
data[10]=Kanal[2]>>8;   
data[11]=Kanal[2]&255;
        
data[12]=Kanal[3]>>8;
data[13]=Kanal[3]&255;

data[14]=Kanal[4]>>8;
data[15]=Kanal[4]&255;
        
data[16]=Kanal[5]>>8;
data[17]=Kanal[5]&255;
        
data[18]=Kanal[6]>>8;
data[19]=Kanal[6]&255;

data[20]=Kanal[7]>>8;
data[21]=Kanal[7]&255;


data_ready=1;
    
}





// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
// Place your code here      



if (Begin==0)
    {
    if (Pause) { Pulse=0; Pause=0;  } 
        if (Pulse==0)  
            { 
            TCNT1=0; TCNT2=0; 
            #asm("wdr")
            Begin_TX1(F1);     //    !!!!!!!!  
            }        
        if (Pulse==1) 
            { 
            TKanal[0]=TCNT1; TCNT1=0; 
             
            }
        if (Pulse==2) 
            { 
            TKanal[1]=TCNT1; TCNT1=0; 
            Begin_TX2(F2);    //    !!!!!!!!         
            }   
        if (Pulse==3) 
            { 
            TKanal[2]=TCNT1; TCNT1=0; 
                        
            }
        if (Pulse==4) 
            { 
            TKanal[3]=TCNT1; TCNT1=0; 
            Begin_TX2(F3);    //    !!!!!!!!         
            }       
        if (Pulse==5) 
            { 
            TKanal[4]=TCNT1; TCNT1=0; 
                        
            }
        if (Pulse==6) 
            { 
            TKanal[5]=TCNT1; TCNT1=0; 
            Begin_TX2(F4);    //    !!!!!!!!         
            }    
        if (Pulse==7) 
            { 
            TKanal[6]=TCNT1; TCNT1=0;  
                        
            }  
        if (Pulse==8) 
            { 
            TKanal[7]=TCNT1; TCNT1=0;  
                        
            }
        
       
        Pulse++;
        

    if (data_ready) 
        { 
        data_ready=0;
        }
    }
else
    {
    TCNT1=0;
    
    }
    


}

// Timer1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
// Place your code here
                       
if (Begin)   //       
    {
    if (In) 
        { 
        Polar=0;    
        MCUCR=0x02;
        }
    else    
        { 
        Polar=1;    
        MCUCR=0x03;
        }
        Begin=0;
    }

else    //   
    {
    Pulse=0;
    Pause=1;
    Copy_K();   
    }   
}

// Timer2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Place your code here


}




// SPI functions
//#include <spi.h>

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=0 State4=T State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0x2F;

// Port C initialization
// Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State6=P State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTC=0x40;
DDRC=0x3F;

// Port D initialization
// Func7=Out Func6=Out Func5=In Func4=Out Func3=Out Func2=In Func1=Out Func0=Out 
// State7=0 State6=0 State5=P State4=0 State3=0 State2=T State1=0 State0=0 
PORTD=0x20;
DDRD=0xDB;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Any change
// INT1: Off
GICR|=0x40;
MCUCR=0x01;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x50;

// USART initialization
// USART disabled
UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 2000,000 kHz
// SPI Clock Phase: Cycle Start
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
//SPCR=0x50;
//SPSR=0x00;
// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 2*2000,000 kHz
// SPI Clock Phase: Cycle Start
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
SPCR=0x50;
SPSR=0x01;






// TWI initialization
// TWI disabled
TWCR=0x00;

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/2048k
#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Global enable interrupts
#asm("sei")


init2_nRF();

Polar=0;
Begin1=0;
Begin2=0; 
Begin=1;
Pause=0;
data_ready=0;

data[0]=Code_1;          
data[1]=Code_2;
data[2]=F1;           //   Kanal
data[3]=F2;          
data[4]=F3;
data[5]=F4;


TCCR0=0x02;  //  1     
          
TCCR1B=0x02;
OCR1A=2500;

while (1)
      {
      // Place your code here
      ;
      }
}
